#include <stdio.h>
#include <node_api.h>
/* typedef enum { false, true } bool; */
#include <stdbool.h>

napi_value MyFunction(napi_env env, napi_callback_info info) {
    napi_status status;
    size_t argc = 1;
    int COUNT = 0;
    napi_value argv[1];
    status = napi_get_cb_info(env, info, &argc, argv, NULL, NULL);
    if (status != napi_ok) {
        napi_throw_error(env, NULL, "Failed to parse arguments");
    }

    status = napi_get_value_int32(env, argv[0], &COUNT);
    if (status != napi_ok) {
        napi_throw_error(env, NULL, "Invalid number was passed as argument");
    }

    napi_value Return;

    int i, z, total = 0;

    for (i = 1; i < COUNT; i++) {

        bool prime = true;
        for (z = 2; z < i - 1; z++) {
			if (i % z == 0) prime = false;
        }
        if (prime == true) total++;

        /* if (prime == true) printf("%d is prime\n", i); */
    }

    status = napi_create_int32(env, total, &Return);
    if (status != napi_ok) {
        napi_throw_error(env, NULL, "Unable to create return value");
    }

    return Return;
}

napi_value Init(napi_env env, napi_value exports) {
    napi_status status;
    napi_value fn;

    status = napi_create_function(env, NULL, 0, MyFunction, NULL, &fn);
    if (status != napi_ok) {
        napi_throw_error(env, NULL, "Unable to wrap native function");
    }

    status = napi_set_named_property(env, exports, "my_function", fn);
    if (status != napi_ok) {
        napi_throw_error(env, NULL, "Unable to populate exports");
    }

    return exports;
}

NAPI_MODULE(NODE_GYP_MODULE_NAME, Init)

    /* int main() { */
    /*     char *fruit = "apple"; */
    /*     int quantity = 1; */

    /*     printf("Oh, hey, I have %d %s%s.", quantity, fruit, (quantity > 1 ? "s" : "")); */


    /*     printf("\n"); */
    /*     return 0; */
    /* } */

